Index: CKEditor/trunk/_source/plugins/forms/dialogs/button.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/button.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/button.js	(revision 6241)
@@ -53,5 +53,5 @@
 						{
 							this.setValue(
-									element.getAttribute( '_cke_saved_name' ) ||
+									element.data( 'cke-saved-name' ) ||
 									element.getAttribute( 'name' ) ||
 									'' );
@@ -62,8 +62,8 @@
 
 							if ( this.getValue() )
-								element.setAttribute( '_cke_saved_name', this.getValue() );
+								element.data( 'cke-saved-name', this.getValue() );
 							else
 							{
-								element.removeAttribute( '_cke_saved_name' );
+								element.data( 'cke-saved-name', false );
 								element.removeAttribute( 'name' );
 							}
Index: CKEditor/trunk/_source/plugins/forms/dialogs/checkbox.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/checkbox.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/checkbox.js	(revision 6241)
@@ -52,5 +52,5 @@
 						{
 							this.setValue(
-									element.getAttribute( '_cke_saved_name' ) ||
+									element.data( 'cke-saved-name' ) ||
 									element.getAttribute( 'name' ) ||
 									'' );
@@ -62,8 +62,8 @@
 							// IE failed to update 'name' property on input elements, protect it now.
 							if ( this.getValue() )
-								element.setAttribute( '_cke_saved_name', this.getValue() );
+								element.data( 'cke-saved-name', this.getValue() );
 							else
 							{
-								element.removeAttribute( '_cke_saved_name' );
+								element.data( 'cke-saved-name', false );
 								element.removeAttribute( 'name' );
 							}
Index: CKEditor/trunk/_source/plugins/forms/dialogs/form.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/form.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/form.js	(revision 6241)
@@ -85,5 +85,5 @@
 						setup : function( element )
 						{
-							this.setValue( element.getAttribute( '_cke_saved_name' ) ||
+							this.setValue( element.data( 'cke-saved-name' ) ||
 									element.getAttribute( 'name' ) ||
 									'' );
@@ -92,8 +92,8 @@
 						{
 							if ( this.getValue() )
-								element.setAttribute( '_cke_saved_name', this.getValue() );
+								element.data( 'cke-saved-name', this.getValue() );
 							else
 							{
-								element.removeAttribute( '_cke_saved_name' );
+								element.data( 'cke-saved-name', false );
 								element.removeAttribute( 'name' );
 							}
Index: CKEditor/trunk/_source/plugins/forms/dialogs/hiddenfield.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/hiddenfield.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/hiddenfield.js	(revision 6241)
@@ -18,5 +18,5 @@
 				element = selection.getSelectedElement();
 
-			if ( element && element.getAttribute( '_cke_real_element_type' ) && element.getAttribute( '_cke_real_element_type' ) == 'hiddenfield' )
+			if ( element && element.data( 'cke-real-element-type' ) && element.data( 'cke-real-element-type' ) == 'hiddenfield' )
 			{
 				this.hiddenField = element;
@@ -60,5 +60,5 @@
 						{
 							this.setValue(
-									element.getAttribute( '_cke_saved_name' ) ||
+									element.data( 'cke-saved-name' ) ||
 									element.getAttribute( 'name' ) ||
 									'' );
Index: CKEditor/trunk/_source/plugins/forms/dialogs/radio.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/radio.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/radio.js	(revision 6241)
@@ -52,5 +52,5 @@
 						{
 							this.setValue(
-									element.getAttribute( '_cke_saved_name' ) ||
+									element.data( 'cke-saved-name' ) ||
 									element.getAttribute( 'name' ) ||
 									'' );
@@ -61,8 +61,8 @@
 
 							if ( this.getValue() )
-								element.setAttribute( '_cke_saved_name', this.getValue() );
+								element.data( 'cke-saved-name', this.getValue() );
 							else
 							{
-								element.removeAttribute( '_cke_saved_name' );
+								element.data( 'cke-saved-name', false );
 								element.removeAttribute( 'name' );
 							}
Index: CKEditor/trunk/_source/plugins/forms/dialogs/select.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/select.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/select.js	(revision 6241)
@@ -194,9 +194,9 @@
 						{
 							if ( name == 'clear' )
-								this.setValue( this['default'] || '' );
+								this.setValue( this[ 'default' ] || '' );
 							else if ( name == 'select' )
 							{
 								this.setValue(
-										element.getAttribute( '_cke_saved_name' ) ||
+										element.data( 'cke-saved-name' ) ||
 										element.getAttribute( 'name' ) ||
 										'' );
@@ -206,8 +206,8 @@
 						{
 							if ( this.getValue() )
-								element.setAttribute( '_cke_saved_name', this.getValue() );
+								element.data( 'cke-saved-name', this.getValue() );
 							else
 							{
-								element.removeAttribute( '_cke_saved_name' ) ;
+								element.data( 'cke-saved-name', false );
 								element.removeAttribute( 'name' );
 							}
Index: CKEditor/trunk/_source/plugins/forms/dialogs/textarea.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/textarea.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/textarea.js	(revision 6241)
@@ -51,5 +51,5 @@
 						{
 							this.setValue(
-									element.getAttribute( '_cke_saved_name' ) ||
+									element.data( 'cke-saved-name' ) ||
 									element.getAttribute( 'name' ) ||
 									'' );
@@ -58,8 +58,8 @@
 						{
 							if ( this.getValue() )
-								element.setAttribute( '_cke_saved_name', this.getValue() );
+								element.data( 'cke-saved-name', this.getValue() );
 							else
 							{
-								element.removeAttribute( '_cke_saved_name' );
+								element.data( 'cke-saved-name', false );
 								element.removeAttribute( 'name' );
 							}
Index: CKEditor/trunk/_source/plugins/forms/dialogs/textfield.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/dialogs/textfield.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/dialogs/textfield.js	(revision 6241)
@@ -99,5 +99,5 @@
 								{
 									this.setValue(
-											element.getAttribute( '_cke_saved_name' ) ||
+											element.data( 'cke-saved-name' ) ||
 											element.getAttribute( 'name' ) ||
 											'' );
@@ -108,8 +108,8 @@
 
 									if ( this.getValue() )
-										element.setAttribute( '_cke_saved_name', this.getValue() );
+										element.data( 'cke-saved-name', this.getValue() );
 									else
 									{
-										element.removeAttribute( '_cke_saved_name' );
+										element.data( 'cke-saved-name', false );
 										element.removeAttribute( 'name' );
 									}
Index: CKEditor/trunk/_source/plugins/forms/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/forms/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/forms/plugin.js	(revision 6241)
@@ -168,5 +168,5 @@
 						}
 
-						if ( name == 'img' && element.getAttribute( '_cke_real_element_type' ) == 'hiddenfield' )
+						if ( name == 'img' && element.data( 'cke-real-element-type' ) == 'hiddenfield' )
 							return { hiddenfield : CKEDITOR.TRISTATE_OFF };
 					}
@@ -184,5 +184,5 @@
 				else if ( element.is( 'textarea' ) )
 					evt.data.dialog = 'textarea';
-				else if ( element.is( 'img' ) && element.getAttribute( '_cke_real_element_type' ) == 'hiddenfield' )
+				else if ( element.is( 'img' ) && element.data( 'cke-real-element-type' ) == 'hiddenfield' )
 					evt.data.dialog = 'hiddenfield';
 				else if ( element.is( 'input' ) )
Index: CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/htmldataprocessor/plugin.js	(revision 6241)
@@ -39,6 +39,10 @@
 	}
 
-	function blockNeedsExtension( block, fromSource )
-	{
+	function blockNeedsExtension( block, fromSource, extendEmptyBlock )
+	{
+		if( !fromSource && ( !extendEmptyBlock ||
+			typeof extendEmptyBlock == 'function' && ( extendEmptyBlock( block ) === false ) ) )
+			return false;
+
         // 1. For IE version >=8,  empty blocks are displayed correctly themself in wysiwiyg;
         // 2. For the rest, at least table cell and list item need no filler space.
@@ -52,30 +56,25 @@
 		var lastChild = lastNoneSpaceChild( block );
 
-		return !lastChild
-			|| lastChild.type == CKEDITOR.NODE_ELEMENT && lastChild.name == 'br'
-			// Some of the controls in form needs extension too,
-			// to move cursor at the end of the form. (#4791)
-			|| block.name == 'form' && lastChild.name == 'input';
-	}
-
-	function extendBlockForDisplay( block )
-	{
-		trimFillers( block, true );
-
-		if ( blockNeedsExtension( block, true ) )
-		{
-			if ( CKEDITOR.env.ie )
-				block.add( new CKEDITOR.htmlParser.text( '\xa0' ) );
-			else
-				block.add( new CKEDITOR.htmlParser.element( 'br', {} ) );
-		}
-	}
-
-	function extendBlockForOutput( block )
-	{
-		trimFillers( block );
-
-		if ( blockNeedsExtension( block ) )
-			block.add( new CKEDITOR.htmlParser.text( '\xa0' ) );
+		return !lastChild || lastChild &&
+				( lastChild.type == CKEDITOR.NODE_ELEMENT && lastChild.name == 'br'
+				// Some of the controls in form needs extension too,
+				// to move cursor at the end of the form. (#4791)
+				|| block.name == 'form' && lastChild.name == 'input' );
+	}
+
+	function getBlockExtension( isOutput, emptyBlockFiller )
+	{
+		return function( node )
+		{
+			trimFillers( node, !isOutput );
+
+			if ( blockNeedsExtension( node, !isOutput, emptyBlockFiller ) )
+			{
+				if ( isOutput || CKEDITOR.env.ie )
+					node.add( new CKEDITOR.htmlParser.text( '\xa0' ) );
+				else
+					node.add( new CKEDITOR.htmlParser.element( 'br', {} ) );
+			}
+		};
 	}
 
@@ -99,5 +98,5 @@
 			// Event attributes (onXYZ) must not be directly set. They can become
 			// active in the editing area (IE|WebKit).
-			[ ( /^on/ ), '_cke_pa_on' ]
+			[ ( /^on/ ), 'data-cke-pa-on' ]
 		]
 	};
@@ -106,5 +105,5 @@
 
 	for ( i in blockLikeTags )
-		defaultDataBlockFilterRules.elements[ i ] = extendBlockForDisplay;
+		defaultDataBlockFilterRules.elements[ i ] = getBlockExtension();
 
 	var defaultHtmlFilterRules =
@@ -122,8 +121,8 @@
 			[
 				// Attributes saved for changes and protected attributes.
-				[ ( /^_cke_(saved|pa)_/ ), '' ],
-
-				// All "_cke" attributes are to be ignored.
-				[ ( /^_cke.*/ ), '' ],
+				[ ( /^data-cke-(saved|pa)-/ ), '' ],
+
+				// All "data-cke" attributes are to be ignored.
+				[ ( /^data-cke.*/ ), '' ],
 
 				[ 'hidefocus', '' ]
@@ -139,5 +138,5 @@
 					{
 						// Elements marked as temporary are to be ignored.
-						if ( attribs.cke_temp )
+						if ( attribs[ 'data-cke-temp' ] )
 							return false;
 
@@ -147,5 +146,5 @@
 						for ( var i = 0 ; i < attributeNames.length ; i++ )
 						{
-							savedAttributeName = '_cke_saved_' + attributeNames[ i ];
+							savedAttributeName = 'data-cke-saved-' + attributeNames[ i ];
 							savedAttributeName in attribs && ( delete attribs[ attributeNames[ i ] ] );
 						}
@@ -182,5 +181,5 @@
 					if ( !( element.children.length ||
 							element.attributes.name ||
-							element.attributes._cke_saved_name ) )
+							element.attributes[ 'data-cke-saved-name' ] ) )
 					{
 						return false;
@@ -188,4 +187,11 @@
 				},
 
+				// Remove dummy span in webkit.
+				span: function( element )
+				{
+					if ( element.attributes[ 'class' ] == 'Apple-style-span' )
+						delete element.name;
+				},
+
 				html : function( element )
 				{
@@ -212,5 +218,5 @@
 				{
 					var titleText = element.children[ 0 ];
-					titleText && ( titleText.value = element.attributes[ '_cke_title' ] || '' );
+					titleText && ( titleText.value = element.attributes[ 'data-cke-title' ] || '' );
 				}
 			},
@@ -243,9 +249,4 @@
 		};
 
-	var defaultHtmlBlockFilterRules = { elements : {} };
-
-	for ( i in blockLikeTags )
-		defaultHtmlBlockFilterRules.elements[ i ] = extendBlockForOutput;
-
 	if ( CKEDITOR.env.ie )
 	{
@@ -274,5 +275,5 @@
 
 	var protectAttributeRegex = /<((?:a|area|img|input)\b[\s\S]*?\s)((href|src|name)\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|(?:[^ "'>]+)))([^>]*)>/gi,
-		findSavedSrcRegex = /\s_cke_saved_src\s*=/;
+		findSavedSrcRegex = /\sdata-cke-saved-src\s*=/;
 
 	var protectElementsRegex = /(?:<style(?=[ >])[^>]*>[\s\S]*<\/style>)|(?:<(:?link|meta|base)[^>]*>)/gi,
@@ -292,5 +293,5 @@
 					return tag;
 				else
-					return '<' + beginning + fullAttr + ' _cke_saved_' + fullAttr + end + '>';
+					return '<' + beginning + fullAttr + ' data-cke-saved-' + fullAttr + end + '>';
 			});
 	}
@@ -413,5 +414,15 @@
 			dataProcessor.dataFilter.addRules( defaultDataBlockFilterRules );
 			dataProcessor.htmlFilter.addRules( defaultHtmlFilterRules );
+
+			var defaultHtmlBlockFilterRules = { elements : {} };
+			for ( i in blockLikeTags )
+				defaultHtmlBlockFilterRules.elements[ i ] = getBlockExtension( true, editor.config.fillEmptyBlocks );
+
 			dataProcessor.htmlFilter.addRules( defaultHtmlBlockFilterRules );
+		},
+
+		onLoad : function()
+		{
+			! ( 'fillEmptyBlocks' in CKEDITOR.config ) && ( CKEDITOR.config.fillEmptyBlocks = 1 );
 		}
 	});
@@ -505,4 +516,5 @@
  * W3C XHTML 1.0 standards (<a href="http://www.w3.org/TR/xhtml1/#C_12">C.12, XHTML 1.0</a>).
  * @name CKEDITOR.config.forceSimpleAmpersand
+ * @name CKEDITOR.config.forceSimpleAmpersand
  * @type Boolean
  * @default false
@@ -510,2 +522,22 @@
  * config.forceSimpleAmpersand = false;
  */
+
+/**
+ * Whether a filler text (non-breaking space entity - &nbsp;) will be inserted into empty block elements in HTML output,
+ * this is used to render block elements properly with line-height; When a function is instead specified,
+ * it'll be passed a {@link CKEDITOR.htmlParser.element} to decide whether adding the filler text
+ * by expecting a boolean return value.
+ * @name CKEDITOR.config.fillEmptyBlocks
+ * @since 3.5
+ * @type Boolean
+ * @default true
+ * @example
+ * config.fillEmptyBlocks = false;	// Prevent filler nodes in all empty blocks.
+ *
+ * // Prevent filler node only in float cleaners.
+ * config.fillEmptyBlocks = function( element )
+ * {
+ * 	if ( element.attributes[ 'class' ].indexOf ( 'clear-both' ) != -1 )
+ * 		return false;
+ * }
+ */
Index: CKEditor/trunk/_source/plugins/iframe/dialogs/iframe.js
===================================================================
--- CKEditor/trunk/_source/plugins/iframe/dialogs/iframe.js	(revision 6241)
+++ CKEditor/trunk/_source/plugins/iframe/dialogs/iframe.js	(revision 6241)
@@ -0,0 +1,257 @@
+﻿/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+(function()
+{
+	// Map 'true' and 'false' values to match W3C's specifications
+	// http://www.w3.org/TR/REC-html40/present/frames.html#h-16.5
+	var checkboxValues =
+	{
+		scrolling : { 'true' : 'yes', 'false' : 'no' },
+		frameborder : { 'true' : '1', 'false' : '0' }
+	};
+
+	function loadValue( iframeNode )
+	{
+		var isCheckbox = this instanceof CKEDITOR.ui.dialog.checkbox;
+		if ( iframeNode.hasAttribute( this.id ) )
+		{
+			var value = iframeNode.getAttribute( this.id );
+			if ( isCheckbox )
+				this.setValue( checkboxValues[ this.id ][ 'true' ] == value.toLowerCase() );
+			else
+				this.setValue( value );
+		}
+	}
+
+	function commitValue( iframeNode )
+	{
+		var isRemove = this.getValue() === '',
+			isCheckbox = this instanceof CKEDITOR.ui.dialog.checkbox,
+			value = this.getValue();
+		if ( isRemove )
+			iframeNode.removeAttribute( this.att || this.id );
+		else if ( isCheckbox )
+			iframeNode.setAttribute( this.id, checkboxValues[ this.id ][ value ] );
+		else
+			iframeNode.setAttribute( this.att || this.id, value );
+	}
+
+	CKEDITOR.dialog.add( 'iframe', function( editor )
+	{
+		var iframeLang = editor.lang.iframe,
+			commonLang = editor.lang.common,
+			dialogadvtab = editor.plugins.dialogadvtab;
+		return {
+			title : iframeLang.title,
+			minWidth : 350,
+			minHeight : 260,
+			onShow : function()
+			{
+				// Clear previously saved elements.
+				this.fakeImage = this.iframeNode = null;
+
+				var fakeImage = this.getSelectedElement();
+				if ( fakeImage && fakeImage.data( 'cke-real-element-type' ) && fakeImage.data( 'cke-real-element-type' ) == 'iframe' )
+				{
+					this.fakeImage = fakeImage;
+
+					var iframeNode = editor.restoreRealElement( fakeImage );
+					this.iframeNode = iframeNode;
+
+					this.setupContent( iframeNode, fakeImage );
+				}
+			},
+			onOk : function()
+			{
+				var iframeNode;
+				if ( !this.fakeImage )
+					iframeNode = new CKEDITOR.dom.element( 'iframe' );
+				else
+					iframeNode = this.iframeNode;
+
+				// A subset of the specified attributes/styles
+				// should also be applied on the fake element to
+				// have better visual effect. (#5240)
+				var extraStyles = {}, extraAttributes = {};
+				this.commitContent( iframeNode, extraStyles, extraAttributes );
+
+				// Refresh the fake image.
+				var newFakeImage = editor.createFakeElement( iframeNode, 'cke_iframe', 'iframe', true );
+				newFakeImage.setAttributes( extraAttributes );
+				newFakeImage.setStyles( extraStyles );
+				if ( this.fakeImage )
+				{
+					newFakeImage.replace( this.fakeImage );
+					editor.getSelection().selectElement( newFakeImage );
+				}
+				else
+					editor.insertElement( newFakeImage );
+			},
+			contents : [
+				{
+					id : 'info',
+					label : commonLang.generalTab,
+					accessKey : 'I',
+					elements :
+					[
+						{
+							type : 'vbox',
+							padding : 0,
+							children :
+							[
+								{
+									id : 'src',
+									type : 'text',
+									label : commonLang.url,
+									required : true,
+									validate : CKEDITOR.dialog.validate.notEmpty( iframeLang.noUrl ),
+									setup : loadValue,
+									commit : commitValue
+								}
+							]
+						},
+						{
+							type : 'hbox',
+							children :
+							[
+								{
+									id : 'width',
+									type : 'text',
+									style : 'width:100%',
+									labelLayout : 'vertical',
+									label : commonLang.width,
+									validate : CKEDITOR.dialog.validate.integer( commonLang.invalidWidth ),
+									setup : function( iframeNode, fakeImage )
+									{
+										loadValue.apply( this, arguments );
+										if ( fakeImage )
+										{
+											var fakeImageWidth = parseInt( fakeImage.$.style.width, 10 );
+											if ( !isNaN( fakeImageWidth ) )
+												this.setValue( fakeImageWidth );
+										}
+									},
+									commit : function( iframeNode, extraStyles )
+									{
+										commitValue.apply( this, arguments );
+										if ( this.getValue() )
+											extraStyles.width = this.getValue() + 'px';
+									}
+								},
+								{
+									id : 'height',
+									type : 'text',
+									style : 'width:100%',
+									labelLayout : 'vertical',
+									label : commonLang.height,
+									validate : CKEDITOR.dialog.validate.integer( commonLang.invalidHeight ),
+									setup : function( iframeNode, fakeImage )
+									{
+										loadValue.apply( this, arguments );
+										if ( fakeImage )
+										{
+											var fakeImageHeight = parseInt( fakeImage.$.style.height, 10 );
+											if ( !isNaN( fakeImageHeight ) )
+												this.setValue( fakeImageHeight );
+										}
+									},
+									commit : function( iframeNode, extraStyles )
+									{
+										commitValue.apply( this, arguments );
+										if ( this.getValue() )
+											extraStyles.height = this.getValue() + 'px';
+									}
+								},
+								{
+									id : 'align',
+									type : 'select',
+									'default' : '',
+									items :
+									[
+										[ commonLang.notSet , '' ],
+										[ commonLang.alignLeft , 'left' ],
+										[ commonLang.alignRight , 'right' ],
+										[ commonLang.alignTop , 'top' ],
+										[ commonLang.alignMiddle , 'middle' ],
+										[ commonLang.alignBottom , 'bottom' ]
+									],
+									style : 'width:100%',
+									labelLayout : 'vertical',
+									label : commonLang.align,
+									setup : function( iframeNode, fakeImage )
+									{
+										loadValue.apply( this, arguments );
+										if ( fakeImage )
+										{
+											var fakeImageAlign = fakeImage.getAttribute( 'align' );
+											this.setValue( fakeImageAlign && fakeImageAlign.toLowerCase() || '' );
+										}
+									},
+									commit : function( iframeNode, extraStyles, extraAttributes )
+									{
+										commitValue.apply( this, arguments );
+										if ( this.getValue() )
+											extraAttributes.align = this.getValue();
+									}
+								}
+							]
+						},
+						{
+							type : 'hbox',
+							widths : [ '50%', '50%' ],
+							children :
+							[
+								{
+									id : 'scrolling',
+									type : 'checkbox',
+									label : iframeLang.scrolling,
+									setup : loadValue,
+									commit : commitValue
+								},
+								{
+									id : 'frameborder',
+									type : 'checkbox',
+									label : iframeLang.border,
+									setup : loadValue,
+									commit : commitValue
+								}
+							]
+						},
+						{
+							type : 'hbox',
+							widths : [ '50%', '50%' ],
+							children :
+							[
+								{
+									id : 'name',
+									type : 'text',
+									label : commonLang.name,
+									setup : loadValue,
+									commit : commitValue
+								},
+								{
+									id : 'title',
+									type : 'text',
+									label : commonLang.advisoryTitle,
+									setup : loadValue,
+									commit : commitValue
+								}
+							]
+						},
+						{
+							id : 'longdesc',
+							type : 'text',
+							label : commonLang.longDescr,
+							setup : loadValue,
+							commit : commitValue
+						}
+					]
+				},
+				dialogadvtab && dialogadvtab.createAdvancedTab( editor, { id:1, classes:1, styles:1 })
+			]
+		};
+	});
+})();
Index: CKEditor/trunk/_source/plugins/iframe/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/iframe/plugin.js	(revision 6241)
+++ CKEditor/trunk/_source/plugins/iframe/plugin.js	(revision 6241)
@@ -0,0 +1,106 @@
+﻿/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+(function()
+{
+	function createFakeElement( editor, realElement )
+	{
+		var fakeElement = editor.createFakeParserElement( realElement, 'cke_iframe', 'iframe', true ),
+			fakeStyle = fakeElement.attributes.style || '';
+
+		var width = realElement.attributes.width,
+			height = realElement.attributes.height;
+
+		if ( typeof width != 'undefined' )
+			fakeStyle += 'width:' + CKEDITOR.tools.cssLength( width ) + ';';
+
+		if ( typeof height != 'undefined' )
+			fakeStyle += 'height:' + CKEDITOR.tools.cssLength( height ) + ';';
+
+		fakeElement.attributes.style = fakeStyle;
+
+		return fakeElement;
+	}
+
+	CKEDITOR.plugins.add( 'iframe',
+	{
+		requires : [ 'dialog', 'fakeobjects' ],
+		init : function( editor )
+		{
+			var pluginName = 'iframe',
+				lang = editor.lang.iframe;
+
+			CKEDITOR.dialog.add( pluginName, this.path + 'dialogs/iframe.js' );
+			editor.addCommand( pluginName, new CKEDITOR.dialogCommand( pluginName ) );
+
+			editor.addCss(
+				'img.cke_iframe' +
+				'{' +
+					'background-image: url(' + CKEDITOR.getUrl( this.path + 'images/placeholder.png' ) + ');' +
+					'background-position: center center;' +
+					'background-repeat: no-repeat;' +
+					'border: 1px solid #a9a9a9;' +
+					'width: 80px;' +
+					'height: 80px;' +
+				'}'
+			);
+
+			editor.ui.addButton( 'Iframe',
+				{
+					label : lang.toolbar,
+					command : pluginName
+				});
+
+			editor.on( 'doubleclick', function( evt )
+				{
+					var element = evt.data.element;
+					if ( element.is( 'img' ) && element.data( 'cke-real-element-type' ) == 'iframe' )
+						evt.data.dialog = 'iframe';
+				});
+
+			if ( editor.addMenuItems )
+			{
+				editor.addMenuItems(
+				{
+					iframe :
+					{
+						label : lang.title,
+						command : 'iframe',
+						group : 'image'
+					}
+				});
+			}
+
+			// If the "contextmenu" plugin is loaded, register the listeners.
+			if ( editor.contextMenu )
+			{
+				editor.contextMenu.addListener( function( element, selection )
+					{
+						if ( element && element.is( 'img' ) && element.data( 'cke-real-element-type' ) == 'iframe' )
+							return { iframe : CKEDITOR.TRISTATE_OFF };
+					});
+			}
+		},
+		afterInit : function( editor )
+		{
+			var dataProcessor = editor.dataProcessor,
+				dataFilter = dataProcessor && dataProcessor.dataFilter;
+
+			if ( dataFilter )
+			{
+				dataFilter.addRules(
+				{
+					elements :
+					{
+						iframe : function( element )
+						{
+							return createFakeElement( editor, element );
+						}
+					}
+				});
+			}
+		}
+	});
+})();
Index: CKEditor/trunk/_source/plugins/image/dialogs/image.js
===================================================================
--- CKEditor/trunk/_source/plugins/image/dialogs/image.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/image/dialogs/image.js	(revision 6241)
@@ -265,5 +265,5 @@
 			title : ( dialogType == 'image' ) ? editor.lang.image.title : editor.lang.image.titleButton,
 			minWidth : 420,
-			minHeight : 310,
+			minHeight : CKEDITOR.env.ie && CKEDITOR.env.quirks?  360: 310,
 			onShow : function()
 			{
@@ -320,5 +320,5 @@
 				}
 
-				if ( element && element.getName() == 'img' && !element.getAttribute( '_cke_realelement' )
+				if ( element && element.getName() == 'img' && !element.data( 'cke-realelement' )
 					|| element && element.getName() == 'input' && element.getAttribute( 'type' ) == 'image' )
 				{
@@ -534,5 +534,5 @@
 												if ( type == IMAGE )
 												{
-													var url = element.getAttribute( '_cke_saved_src' ) || element.getAttribute( 'src' );
+													var url = element.data( 'cke-saved-src' ) || element.getAttribute( 'src' );
 													var field = this;
 
@@ -548,5 +548,5 @@
 												if ( type == IMAGE && ( this.getValue() || this.isChanged() ) )
 												{
-													element.setAttribute( '_cke_saved_src', decodeURI( this.getValue() ) );
+													element.data( 'cke-saved-src', decodeURI( this.getValue() ) );
 													element.setAttribute( 'src', decodeURI( this.getValue() ) );
 												}
@@ -608,15 +608,13 @@
 						{
 							type : 'hbox',
-							widths : [ '140px', '240px' ],
 							children :
 							[
 								{
 									type : 'vbox',
-									padding : 10,
 									children :
 									[
 										{
 											type : 'hbox',
-											widths : [ '70%', '30%' ],
+											widths : [ '50%', '50%' ],
 											children :
 											[
@@ -630,6 +628,5 @@
 															width: '40px',
 															id : 'txtWidth',
-															labelLayout : 'horizontal',
-															label : editor.lang.image.width,
+															label : editor.lang.common.width,
 															onKeyUp : onSizeChange,
 															onChange : function()
@@ -641,5 +638,5 @@
 																var aMatch  =  this.getValue().match( regexGetSizeOrEmpty );
 																if ( !aMatch )
-																	alert( editor.lang.image.validateWidth );
+																	alert( editor.lang.common.invalidWidth );
 																return !!aMatch;
 															},
@@ -680,6 +677,5 @@
 															id : 'txtHeight',
 															width: '40px',
-															labelLayout : 'horizontal',
-															label : editor.lang.image.height,
+															label : editor.lang.common.height,
 															onKeyUp : onSizeChange,
 															onChange : function()
@@ -691,5 +687,5 @@
 																var aMatch = this.getValue().match( regexGetSizeOrEmpty );
 																if ( !aMatch )
-																	alert( editor.lang.image.validateHeight );
+																	alert( editor.lang.common.invalidHeight );
 																return !!aMatch;
 															},
@@ -731,5 +727,5 @@
 												{
 													type : 'html',
-													style : 'margin-top:10px;width:40px;height:40px;',
+													style : 'margin-top:30px;width:40px;height:40px;',
 													onLoad : function()
 													{
@@ -801,5 +797,4 @@
 													id : 'txtBorder',
 													width: '60px',
-													labelLayout : 'horizontal',
 													label : editor.lang.image.border,
 													'default' : '',
@@ -858,5 +853,4 @@
 													id : 'txtHSpace',
 													width: '60px',
-													labelLayout : 'horizontal',
 													label : editor.lang.image.hSpace,
 													'default' : '',
@@ -922,5 +916,4 @@
 													id : 'txtVSpace',
 													width : '60px',
-													labelLayout : 'horizontal',
 													label : editor.lang.image.vSpace,
 													'default' : '',
@@ -984,14 +977,13 @@
 													id : 'cmbAlign',
 													type : 'select',
-													labelLayout : 'horizontal',
 													widths : [ '35%','65%' ],
 													style : 'width:90px',
-													label : editor.lang.image.align,
+													label : editor.lang.common.align,
 													'default' : '',
 													items :
 													[
 														[ editor.lang.common.notSet , ''],
-														[ editor.lang.image.alignLeft , 'left'],
-														[ editor.lang.image.alignRight , 'right']
+														[ editor.lang.common.alignLeft , 'left'],
+														[ editor.lang.common.alignRight , 'right']
 														// Backward compatible with v2 on setup when specified as attribute value,
 														// while these values are no more available as select options.
@@ -1099,5 +1091,5 @@
 								if ( type == LINK )
 								{
-									var href = element.getAttribute( '_cke_saved_href' );
+									var href = element.data( 'cke-saved-href' );
 									if ( !href )
 										href = element.getAttribute( 'href' );
@@ -1111,5 +1103,5 @@
 									if ( this.getValue() || this.isChanged() )
 									{
-										element.setAttribute( '_cke_saved_href', decodeURI( this.getValue() ) );
+										element.data( 'cke-saved-href', decodeURI( this.getValue() ) );
 										element.setAttribute( 'href', 'javascript:void(0)/*' +
 											CKEDITOR.tools.getNextNumber() + '*/' );
Index: CKEditor/trunk/_source/plugins/image/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/image/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/image/plugin.js	(revision 6241)
@@ -31,5 +31,5 @@
 				var element = evt.data.element;
 
-				if ( element.is( 'img' ) && !element.getAttribute( '_cke_realelement' ) )
+				if ( element.is( 'img' ) && !element.data( 'cke-realelement' ) )
 					evt.data.dialog = 'image';
 			});
@@ -54,5 +54,5 @@
 			editor.contextMenu.addListener( function( element, selection )
 				{
-					if ( !element || !element.is( 'img' ) || element.getAttribute( '_cke_realelement' ) || element.isReadOnly() )
+					if ( !element || !element.is( 'img' ) || element.data( 'cke-realelement' ) || element.isReadOnly() )
 						return null;
 
